@echo off

cls.

echo.
echo ---------------------------------------
echo Evolis Pebble4/Dualys3/Tattoo2/Quantum2/Securion Driver Patch for Windows 10/11
echo by Daniel Marschall, ViaThinkSoft
echo Revision 3 July 2025
echo ---------------------------------------
echo.

set ThisDir=%~dp0

rem Check if we have 64 Bit Windows

if "%PROCESSOR_ARCHITECTURE%"=="AMD64" ( goto bit64 ) else ( goto bit32 )

:bit32
color 2f
echo.
echo.
echo.
echo.
echo You are using 32 bit Windows.
echo You don't need a patch for the Evolis drivers!
echo.
echo.
echo.
echo.
pause.
color
exit /b

:bit64

rem Check if we are not UNC

if "%ThisDir:~0,2%"=="\\" (
	color 4f
	echo.
	echo.
	echo.
	echo.
	echo Error: This script cannot be run from a UNC path. Please copy it to a local drive.
	echo.
	echo.
	echo.
	echo.
	pause.
	exit /b 1
)

rem Check if RemoteDesktop is not running

tasklist /FI "IMAGENAME eq mstsc.exe" | find /I "mstsc.exe" >nul
if %errorlevel%==0 (
	color 4f
	echo.
	echo.
	echo.
	echo.
	echo Error: Please exit Microsoft Remote Desktop ^(otherwise replacing the spooler files might fail^)
	echo.
	echo.
	echo.
	echo.
	pause.
	exit /b 1
)

rem Elevate process

NET FILE 1>NUL 2>NUL
if "%errorlevel%"=="0" ( goto gotPrivileges ) else ( goto getPrivileges )

:getPrivileges
echo Will now elevate to administrator privileges
echo.
"%ThisDir%bin\nircmdc.exe" elevate "%~f0"
color
exit /b

:gotPrivileges

rem ----------------------------------------------------------------------------

rem Now run as system user

whoami | findstr /i "system"
if %errorlevel%==0 (
    rem Running as SYSTEM
) else (
    rem Not running as SYSTEM
    "%ThisDir%bin\psexec.exe" -nobanner -accepteula -s -i cmd /c call "%~f0"
    exit /b
)

rem ----------------------------------------------------------------------------

set "CopyErrors=0"

echo Update DriverStore

for /D %%I in ("%systemroot%\System32\DriverStore\FileRepository\youn.inf*") do (
	if exist "%%I\amd64\YOUNUI.DLL" (
		echo Replace 64 Bit DriverStore Pebble4 YOUNUI.DLL
		echo SRC:  "%ThisDir%amd64\YOUNUI.DLL"
		echo DEST: "%%I\amd64\YOUNUI.DLL"
		xcopy /y "%ThisDir%amd64\YOUNUI.DLL" "%%I\amd64\YOUNUI.DLL"
		if errorlevel 1 (
			echo "!!!!!!!! COPY ERROR !!!!!!!!"
			set /a CopyErrors+=1
		)
	)
)

for /D %%I in ("%systemroot%\System32\DriverStore\FileRepository\youndu.inf*") do (
	if exist "%%I\amd64\YOUNDUUI.DLL" (
		echo Replace 64 Bit DriverStore Dualys3 YOUNDUUI.DLL
		echo SRC:  "%ThisDir%amd64\YOUNDUUI.DLL"
		echo DEST: "%%I\amd64\YOUNDUUI.DLL"
		xcopy /y "%ThisDir%amd64\YOUNDUUI.DLL" "%%I\amd64\YOUNDUUI.DLL"
		if errorlevel 1 (
			echo "!!!!!!!! COPY ERROR !!!!!!!!"
			set /a CopyErrors+=1
		)
	)
)

for /D %%I in ("%systemroot%\System32\DriverStore\FileRepository\yount2.inf*") do (
	if exist "%%I\amd64\YOUNT2UI.DLL" (
		echo Replace 64 Bit DriverStore Tattoo2 YOUNT2UI.DLL
		echo SRC:  "%ThisDir%amd64\YOUNT2UI.DLL"
		echo DEST: "%%I\amd64\YOUNT2UI.DLL"
		xcopy /y "%ThisDir%amd64\YOUNT2UI.DLL" "%%I\amd64\YOUNT2UI.DLL"
		if errorlevel 1 (
			echo "!!!!!!!! COPY ERROR !!!!!!!!"
			set /a CopyErrors+=1
		)
	)
)

for /D %%I in ("%systemroot%\System32\DriverStore\FileRepository\tattoorw.inf") do (
	if exist "%%I\amd64\TATTOORWUI.DLL" (
		echo Replace 64 Bit DriverStore TattooRW2 TATTOORWUI.DLL
		echo SRC:  "%ThisDir%amd64\TATTOORWUI.DLL"
		echo DEST: "%%I\amd64\TATTOORWUI.DLL"
		xcopy /y "%ThisDir%amd64\TATTOORWUI.DLL" "%%I\amd64\TATTOORWUI.DLL"
		if errorlevel 1 (
			echo "!!!!!!!! COPY ERROR !!!!!!!!"
			set /a CopyErrors+=1
		)
	)
)

for /D %%I in ("%systemroot%\System32\DriverStore\FileRepository\younof2.inf*") do (
	if exist "%%I\amd64\YOUNOF2UI.DLL" (
		echo Replace 64 Bit DriverStore Quantum2 YOUNOF2UI.DLL
		echo SRC:  "%ThisDir%amd64\YOUNOF2UI.DLL"
		echo DEST: "%%I\amd64\YOUNOF2UI.DLL"
		xcopy /y "%ThisDir%amd64\YOUNOF2UI.DLL" "%%I\amd64\YOUNOF2UI.DLL"
		if errorlevel 1 (
			echo "!!!!!!!! COPY ERROR !!!!!!!!"
			set /a CopyErrors+=1
		)
	)
)

for /D %%I in ("%systemroot%\System32\DriverStore\FileRepository\younse.inf*") do (
	if exist "%%I\amd64\YOUNSEUI.DLL" (
		echo Replace 64 Bit DriverStore Securion YOUNSEUI.DLL
		echo SRC:  "%ThisDir%amd64\YOUNSEUI.DLL"
		echo DEST: "%%I\amd64\YOUNSEUI.DLL"
		xcopy /y "%ThisDir%amd64\YOUNSEUI.DLL" "%%I\amd64\YOUNSEUI.DLL"
		if errorlevel 1 (
			echo "!!!!!!!! COPY ERROR !!!!!!!!"
			set /a CopyErrors+=1
		)
	)
)

rem ----------------------------------------------------------------------------

echo Update Program Files

Set TargetDir=%ProgramFiles%\Evolis Card Printer\Drivers Pebble4\amd64\
if exist "%TargetDir%\YOUNUI.DLL" (
	echo Replace 64 Bit ProgramFiles Pebble4 YOUNUI.DLL
	xcopy /y "%ThisDir%amd64\YOUNUI.DLL" "%TargetDir%\YOUNUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
Set TargetDir=%ProgramFiles%\Evolis Card Printer\Drivers Dualys3\amd64\
if exist "%TargetDir%\YOUNDUUI.DLL" (
	echo Replace 64 Bit ProgramFiles Dualys3 YOUNDUUI.DLL
	xcopy /y "%ThisDir%amd64\YOUNDUUI.DLL" "%TargetDir%\YOUNDUUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
Set TargetDir=%ProgramFiles%\Evolis Card Printer\Drivers Tattoo2\amd64\
if exist "%TargetDir%\YOUNT2UI.DLL" (
	echo Replace 64 Bit ProgramFiles Tattoo2 YOUNT2UI.DLL
	xcopy /y "%ThisDir%amd64\YOUNT2UI.DLL" "%TargetDir%\YOUNT2UI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
Set TargetDir=%ProgramFiles%\Evolis Card Printer\Drivers Tattoo Rewrite\amd64\
if exist "%TargetDir%\TATTOORWUI.DLL" (
	echo Replace 64 Bit ProgramFiles TattooRW2 TATTOORWUI.DLL
	xcopy /y "%ThisDir%amd64\TATTOORWUI.DLL" "%TargetDir%\TATTOORWUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
Set TargetDir=%ProgramFiles%\Evolis Card Printer\Drivers Quantum2\amd64\
if exist "%TargetDir%\YOUNOF2UI.DLL" (
	echo Replace 64 Bit ProgramFiles Quantum2 YOUNOF2UI.DLL
	xcopy /y "%ThisDir%amd64\YOUNOF2UI.DLL" "%TargetDir%\YOUNOF2UI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
Set TargetDir=%ProgramFiles%\Evolis Card Printer\Drivers Securion\amd64\
if exist "%TargetDir%\YOUNSEUI.DLL" (
	echo Replace 64 Bit ProgramFiles Securion YOUNSEUI.DLL
	xcopy /y "%ThisDir%amd64\YOUNSEUI.DLL" "%TargetDir%\YOUNSEUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)

rem ----------------------------------------------------------------------------

echo Update Spooler
net stop spooler

Set TargetDir=%systemroot%\System32\spool\drivers\x64\
if exist "%TargetDir%\YOUNUI.DLL" (
	echo Replace 64 Bit Spool Pebble4 YOUNUI.DLL
	xcopy /y "%ThisDir%amd64\YOUNUI.DLL" "%TargetDir%\YOUNUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
if exist "%TargetDir%\YOUNDUUI.DLL" (
	echo Replace 64 Bit Spool Dualys3 YOUNDUUI.DLL
	xcopy /y "%ThisDir%amd64\YOUNDUUI.DLL" "%TargetDir%\YOUNDUUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
if exist "%TargetDir%\YOUNT2UI.DLL" (
	echo Replace 64 Bit Spool Tattoo2 YOUNT2UI.DLL
	xcopy /y "%ThisDir%amd64\YOUNT2UI.DLL" "%TargetDir%\YOUNT2UI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
if exist "%TargetDir%\TATTOORWUI.DLL" (
	echo Replace 64 Bit Spool TattooRW2 TATTOORWUI.DLL
	xcopy /y "%ThisDir%amd64\TATTOORWUI.DLL" "%TargetDir%\TATTOORWUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
if exist "%TargetDir%\YOUNOF2UI.DLL" (
	echo Replace 64 Bit Spool Quantum2 YOUNOF2UI.DLL
	xcopy /y "%ThisDir%amd64\YOUNOF2UI.DLL" "%TargetDir%\YOUNOF2UI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
if exist "%TargetDir%\YOUNSEUI.DLL" (
	echo Replace 64 Bit Spool Securion YOUNSEUI.DLL
	xcopy /y "%ThisDir%amd64\YOUNSEUI.DLL" "%TargetDir%\YOUNSEUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)

Set TargetDir=%systemroot%\System32\spool\drivers\x64\3\
if exist "%TargetDir%\YOUNUI.DLL" (
	echo Replace 64 Bit Spool\3 Pebble4 YOUNUI.DLL
	xcopy /y "%ThisDir%amd64\YOUNUI.DLL" "%TargetDir%\YOUNUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
if exist "%TargetDir%\YOUNDUUI.DLL" (
	echo Replace 64 Bit Spool\3 Dualys3 YOUNDUUI.DLL
	xcopy /y "%ThisDir%amd64\YOUNDUUI.DLL" "%TargetDir%\YOUNDUUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
if exist "%TargetDir%\YOUNT2UI.DLL" (
	echo Replace 64 Bit Spool\3 Tattoo2 YOUNT2UI.DLL
	xcopy /y "%ThisDir%amd64\YOUNT2UI.DLL" "%TargetDir%\YOUNT2UI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
if exist "%TargetDir%\TATTOORWUI.DLL" (
	echo Replace 64 Bit Spool\3 TattooRW2 TATTOORWUI.DLL
	xcopy /y "%ThisDir%amd64\TATTOORWUI.DLL" "%TargetDir%\TATTOORWUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
if exist "%TargetDir%\YOUNOF2UI.DLL" (
	echo Replace 64 Bit Spool\3 Quantum2 YOUNOF2UI.DLL
	xcopy /y "%ThisDir%amd64\YOUNOF2UI.DLL" "%TargetDir%\YOUNOF2UI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)
if exist "%TargetDir%\YOUNSEUI.DLL" (
	echo Replace 64 Bit Spool\3 Securion YOUNSEUI.DLL
	xcopy /y "%ThisDir%amd64\YOUNSEUI.DLL" "%TargetDir%\YOUNSEUI.DLL"
	if errorlevel 1 (
		echo "!!!!!!!! COPY ERROR !!!!!!!!"
		set /a CopyErrors+=1
	)
)

net start spooler

if %CopyErrors%==0 (
	color 2f
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo ---------------------------------------
	echo ALL DONE. YOU CAN NOW CLOSE THE WINDOW
	echo If it does not work, try to restart your computer
	echo ---------------------------------------
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	timeout 10
	exit /b 0
) else (
	color 4f
	echo.
	echo.
	echo.
	echo.
	echo ERROR: %CopyErrors% files could not be copied. Please close all applications and/or restart your computer and try again.
	echo.
	echo.
	echo.
	echo.
	pause.
	exit /b 1
)
